/* COPYRIGHT - BowenStudios - 2014 */

/* Auto bake high-poly revealed-stucco to low-poly ... (still retains bevel "lines" ... for the time being) */



/*enableSceneRedraw()*/


strWarning = "This 'Low-Poly from High-Poly' utility will (upon the selected objects) delete all modifiers, except the following: Edit Mesh, Sweep, Bevel, and Extrude. IF THERE ARE ANY EMPTY OBJECTS, LIKE SHAPE OR LINE OBJECTS THAT HAVE NO VERTICES, THIS WILL FAIL ... oh, and all layers must be turned-on that contain sweep profile shapes ... \n\n ... oh, and each window/door system must have an Edit Mesh modifier (even if verticies are not manipulated)  ... \n\nWould you like to Continue?"


strFileNameDelim = "_"
/*strLowPolyPostName = "_LOW_"*/
strLowPolyPostName = "_LP"

dblNetExtrudeForMove = 0.0
dblNetExtrude = 0.0
dblNetExtrudeBuffer = 1.01
/*dblNetExtrudeBuffer = 0.01*/
dblNetExtrudeBuffered = 0.0
dblDefaultCagePush = 0.15

arrObjsForExport = #()

needExtrudedReplacement = false

wasExtruded = false

bolContinueModStackWalk = true

bolDoDel = true

bolDoMove = false

bolDoBake = true

intPreElimObjSteps = 1
bolPreElimObjOptimize = true
bolPreElimObjAdaptive = true

intPreElimShapeSteps = 1
bolPreElimShapeOptimize = true
bolPreElimShapeAdaptive = false

intVezObjInSel = 0


bolIsFromFloorGen = false
arrOpenEdges = #()
arrObjCloneCopiedBB = #()


arrSweepShapeCloneSources = #()
arrSweepShapeCloneCopied = #()

isTypicalWall = false

hadDisplacement = false


fn strSterilize strPassed = 
	(
		strPassed = substituteString strPassed " " "_"
		strPassed = substituteString strPassed "'" "ft"
		strPassed = substituteString strPassed "[" "-"
		strPassed = substituteString strPassed "]" "-"
		strPassed = substituteString strPassed "(" "-"
		strPassed = substituteString strPassed ")" "-"
		strPassed = substituteString strPassed "/" "-"
		strPassed = substituteString strPassed "\\" "-"
		substituteString strPassed "\"" "in"
	)



fn pushGateRecursively objPassed dblNetExtrudePassed = 
	(
		select objPassed
		/*format "\n\t Initiated pushGateRecursively for [[%(%)]] = dblNetExtrudePassed[[%]]" objPassed.name (classof objPassed) dblNetExtrudePassed*/
		
		/*format "\n\nPost-Include (LP'd) -- in pushGateRecursively: objCloneCopied = [[%]]\n" objPassed.name
		format "\tdblNetExtrudePassed = [[%]]\n" dblNetExtrudePassed*/
		
		$.modifiers[#Projection].pushValue = dblNetExtrudePassed
		/*format "\n\t\t Cage pre-Push of [[%]] = dblNetExtrudePassed[[%]] (pushValue[[%]])" objPassed.name dblNetExtrudePassed $.modifiers[#Projection].pushValue*/
					
		$.modifiers[#Projection].pushCage($.modifiers[#Projection].pushValue)
		
		$.modifiers[#Projection].displayCage = true
		/*format "\n\t\t\t Cage post-Push of [[%]] = dblNetExtrudePassed[[%]] (pushValue[[%]]) \n\n" objPassed.name dblNetExtrudePassed $.modifiers[#Projection].pushValue*/
		
		/*forcecompleteRedraw()*/
	)



fn myFlatten objPassed flattenAngle:45 flattenSpacing:0.02 flattenRotate:true flattenFillHoles:true flattenAll:false setMapChannel:1 = 
	(
		/* from Neil Blevin's Soulburn script: texmapBaker.ms */
		
		/*select objPassed*/
		
		/*   ----  DO IT HERE !!!  ----   */
		(
			max modify mode
			
				select objPassed
			
					unwrapMod = unwrap_UVW()
					addModifier objPassed unwrapMod
					unwrapMod.setPreventFlattening off
					unwrapMod.setMapChannel setMapChannel
					unwrapMod.mappingReset()
					allfaces = for i = 1 to (unwrapMod.numberPolygons()) collect i
					unwrapMod.selectFaces (allfaces as bitarray)
					unwrapMod.flattenMap flattenAngle #([1,0,0], [-1,0,0], [0,1,0], [0,-1,0], [0,0,1], [0,0,-1]) flattenSpacing true 0 flattenRotate flattenFillHoles
					
				deselect objPassed
		)
	)





fn bakeHighNormalsToLow objToBakeOnto intMapSize:1024 dblMultiplier:1.0 = 
	(
		strJustFileName = getFilenameFile maxFileName
		strSterilizedFileName = strSterilize strJustFileName
		strSterilizedObjName = strSterilize objToBakeOnto.name
			
			
		objToBakeOnto.iNodeBakeProperties.removeAllBakeElements()
		
		
		objToBakeOntoProjProps = objToBakeOnto.iNodeBakeProjProperties
		objToBakeOntoProjProps.useCage = true
		objToBakeOntoProjProps.normalSpace = #tangent
		/* for Unity */
		objToBakeOntoProjProps.tangentYDir = #Y_Up
		objToBakeOntoProjProps.tangentXDir = #X_Right
		
		
		
			beDiffuse = VRayCompleteMap()
		
			beDiffuse.autoSzOn = false
			
			beDiffuse.outputSzX = intMapSize
			beDiffuse.outputSzY = intMapSize
			
			/*beDiffuse.fileType = ("" + maxFilePath + strSterilizedFileName + strFileNameDelim + strSterilizedObjName + strFileNameDelim + beDiffuse.elementName + ".tga")*/
			beDiffuse.fileType = ("" + maxFilePath + strSterilizedFileName + strFileNameDelim + strSterilizedObjName + strFileNameDelim + "vC" + ".tga")
			beDiffuse.fileName = filenameFromPath beDiffuse.fileType
			
			
			beDiffuse.filterOn = false
			beDiffuse.atmosphereOn = true
			beDiffuse.shadowOn = true
			beDiffuse.vrayVFB = false
			beDiffuse.color_mapping = true /*  what should this setting be ?  */
			beDiffuse.multiplier = dblMultiplier
			
			beDiffuse.targetMapSlotName = "Diffuse map"
			
			beDiffuse.enabled = true
		
		
		
			beNormals = VRayNormalsMap()
			
			beNormals.autoSzOn = false
			
			beNormals.outputSzX = intMapSize
			beNormals.outputSzY = intMapSize
			
			/*beNormals.fileType = ("" + maxFilePath + strSterilizedFileName + strFileNameDelim + strSterilizedObjName + strFileNameDelim + beNormals.elementName + ".tga")*/
			beNormals.fileType = ("" + maxFilePath + strSterilizedFileName + strFileNameDelim + strSterilizedObjName + strFileNameDelim + "vN" + ".tga")
			beNormals.fileName = filenameFromPath beNormals.fileType
			
			
			beNormals.filterOn = false
			beNormals.atmosphereOn = false
			beNormals.shadowOn = false
			beNormals.vrayVFB = false
			/*beNormals.color_mapping = false*/
			/*beNormals.multiplier = dblMultiplier*/
			
			beNormals.targetMapSlotName = "Bump map"
			
			beNormals.enabled = true
			
			
		objToBakeOntoProjProps.enabled = true
		objToBakeOntoProjProps.projectionMod = objToBakeOnto.modifiers[#Projection]
		objToBakeOntoProjProps.projectionModTarget = objToBakeOnto.modifiers[#Projection].name
		
		objToBakeOntoProjProps.BakeObjectLevel = true
		objToBakeOntoProjProps.BakeSubObjLevels = true
		objToBakeOntoProjProps.useObjectBakeForMtl = true
		objToBakeOntoProjProps.subObjBakeChannel = 4
		
		objToBakeOntoProps = objToBakeOnto.iNodeBakeProperties
		objToBakeOntoProps.addBakeElement beNormals
		objToBakeOntoProps.addBakeElement beDiffuse
		objToBakeOntoProps.bakeEnabled = true
		objToBakeOntoProps.bakeChannel = 1
		objToBakeOntoProps.nDilations = 2
		
		/* DEBUG */
				/* format "\n\n\t got here [[%]] for [[%]]" "IN:'bakeHighNormalsToLow' PRE:'select objToBakeOnto'" objToBakeOnto.name */
		/* DEBUG */
		
		select objToBakeOnto
		render rendertype:#bakeSelected vfb:off progressBar:true outputSize:[intMapSize,intMapSize]
		max select none
		
		mapBakedDiffuse = bitmaptexture fileName:beDiffuse.fileType
		txmapNorm = bitmaptexture filename:beNormals.fileType
			mapBakedNormals = normal_bump normal_map:txmapNorm
		
		/*mtlBaked = vraymtl texmap_diffuse:mapBakedDiffuse texmap_bump:mapBakedNormals*/
		
		objToBakeOnto.material.diffuseMap = mapBakedDiffuse
		objToBakeOnto.material.bumpMap = mapBakedNormals
		
		/*objToBakeOnto.material = mtlBaked*/
	)



bolDoThisScript = querybox strWarning title:"LP copies from HP geom" beep:true


if (bolDoThisScript) do 
	(
		maxOps.cloneNodes $ clonetype:#copy actualNodeList:&arrObjCloneSources newNodes:&arrObjCloneCopied
		max select none


		arrIndex = 1

		for objCloneCopied in arrObjCloneCopied do 
			(
				strSterilizedNameObjCloneCopied = strSterilize objCloneCopied.name
				objCloneCopied.name = strSterilizedNameObjCloneCopied
				
				if ((classof objCloneCopied) != Dummy) do
					(
						if ((objCloneCopied.modifiers.count == 0) and (superclassof objCloneCopied == shape)) then
							(
								/* has no modifiers AND is just a line, rectangle, circle ... etc. -- SKIP ! */
									bolDoBake = false
									/*delete objCloneCopied*/
							)
						else
							(
								/*  NEED TO CHECK IF HAS ZERO VERTS  */
							
								if (objCloneCopied.verts.count >= 1) then
									(
										strBakedMtlName = "baked-std_" + (strSterilize objCloneCopied.name) + ""
										mtlBakedInit = standard name:strBakedMtlName showInViewport:true
											mtlBakedInit.diffuseMapEnable = true
											mtlBakedInit.bumpMapEnable = true
											mtlBakedInit.bumpMapAmount = 300
										
										objCloneCopied.material = mtlBakedInit
										
										/* is already walking the modifier stack at line 88 in BS-HP2LP_forBake.ms ... no need to loop here */
											/*
												for i=1 to objCloneCopied.modifiers.count do
													(*/
														
														/*case objCloneCopied.modifiers[1].name of 
															(
																"Bevel":
																	(
																		dblNetExtrudeForMove = objCloneCopied.modifiers[1].Level_1_Height + objCloneCopied.modifiers[1].Level_2_Height
																		dblNetExtrude = dblNetExtrudeForMove + objCloneCopied.modifiers[1].Level_3_Height
																		dblNetExtrudeBuffered = dblNetExtrude * dblNetExtrudeBuffer
																	)
																"Extrude":
																	(
																		dblNetExtrudeForMove = objCloneCopied.modifiers[1].amount
																		dblNetExtrude = dblNetExtrudeForMove
																		dblNetExtrudeBuffered = dblNetExtrude * dblNetExtrudeBuffer
																	)
															)
														
														deleteModifier objCloneCopied 1
														*/
														
														/*format "\n\nPre-Include: objCloneCopied = [[%]]\n" objCloneCopied.name
														format "\tdblNetExtrudeBuffered = [[%]]\n" dblNetExtrudeBuffered*/
														
														include "P:\_start files\MAX 2014\MacroScripts\BS-HP2LP_forBake.ms"
														
														/*format "\n\nPost-Include -- in Main: objCloneCopied = [[%]]\n" objCloneCopied.name
														format "\tdblNetExtrudeBuffered = [[%]]\n\n" dblNetExtrudeBuffered*/
													/*)
											*/
												
											if (bolDoBake) do
												(
													select objCloneCopied
													macros.run "Modifier Stack" "Convert_to_Mesh"
													max select none
														
													
													strOrigName = objCloneCopied.name
													strNewName = strOrigName + strLowPolyPostName
													
													objCloneCopied.name = strNewName
														/*format "[[%]]'s copy ([[%]]) renamed to [[%]]" arrObjCloneSources[(finditem arrObjCloneCopied objCloneCopied)].name strOrigName strNewName*/
													
													addModifier objCloneCopied (Projection ())
														objCloneCopied.modifiers[#Projection].resetCage()
														
														objCloneCopied.modifiers[#Projection].displayCageShaded = on
															
															/*strDebug_pushValue = "" + objCloneCopied.name + ".dblNetExtrudeBuffered[" + ((dblNetExtrudeBuffered as float) as string) + "]"
																print strDebug_pushValue*/
														
														
														/*format "\n\n Prepared to pushGateRecursively for [[%]] = dblNetExtrudeBuffered[[%]]" objCloneCopied.name dblNetExtrudeBuffered*/
														pushGateRecursively objCloneCopied dblNetExtrudeBuffered
																/*strDebug_pushed = "" + objCloneCopied.name + ".bolPushedCage[" + (strDebug_pushed as string) + "]"
																	print strDebug_pushed*/
														
														/* from http://www.scriptspot.com/forums/3ds-max/general-scripting/normal-map-baking */
														objCloneCopied.modifiers[#Projection].addObjectNode arrObjCloneSources[arrIndex]
														
														objCloneCopied.modifiers[#Projection].displayCageShaded = off
													
													/*
													arrObjsForBatchFlatten = #()
														append arrObjsForBatchFlatten objCloneCopied
															strDidFlatten = BatchFlatten arrObjsForBatchFlatten
																print strDidFlatten
														deleteItem arrObjsForBatchFlatten 1
													free arrObjsForBatchFlatten
													*/
													
													arrObjsForBatchFlatten = #()				
														append arrObjsForBatchFlatten objCloneCopied
															strDidFlatten = myFlatten arrObjsForBatchFlatten setMapChannel:1
																print strDidFlatten
														deleteItem arrObjsForBatchFlatten 1
													free arrObjsForBatchFlatten
													
													
													
													/* BAKE IT */
													
														bakeHighNormalsToLow objCloneCopied
														
													/* BAKE IT */
											
											
											
													/* finnaggle with testing */
														/*IntPercentLessExtrude = 20*/
													/*  */
																
													/*
													percentOfExtrude = (1 - (IntPercentLessExtrude / 100))
													dblMoveInNorm = dblNetExtrude * percentOfExtrude
													*/
													
													/*format "\n\t [[%]].bolDoMove == [[%]]" objCloneCopied.name (bolDoMove as string)*/
													
													if (bolDoMove) then
														(
															dblMoveInNorm = dblNetExtrudeForMove
															
															in coordsys local move objCloneCopied [0,0,dblMoveInNorm]
																
															/*format "\n\t moved [[%]] = [[%]]" objCloneCopied.name dblMoveInNorm*/
														)
													else
														(
															/*format "\n\t will not move [[%]]" objCloneCopied.name*/
														)
													
													
													intThisBakedObjIndex = finditem arrObjCloneCopied objCloneCopied
													strNameObjOrigForThisIndex = arrObjCloneSources[intThisBakedObjIndex].name
													
													intNextBakeObjIndex = intThisBakedObjIndex
													
													if (intThisBakedObjIndex < arrObjCloneCopied.count) do
														(
															intNextBakeObjIndex = (intThisBakedObjIndex + 1)
														)
														
													strNameObjOrigForNextIndex = arrObjCloneSources[intNextBakeObjIndex].name
													strNameObjBakeForNextIndex = arrObjCloneCopied[intNextBakeObjIndex].name
													
													format "\n\n\t baked [[%]] as [[%]]\n\t\t([[%]] is the next source obj to bake as [[%]])\n" strNameObjOrigForThisIndex objCloneCopied.name strNameObjOrigForNextIndex strNameObjBakeForNextIndex
												)
										
										
										arrIndex += 1
									)
								else
									(
										delete objCloneCopied
									)
							)
					)
			)
	)


	

/* save-out new geom */
	/* for obj in geometry do format "\n [[%]]] isLow=[[%]]" obj.name (findstring obj.name "__LOW_") */
	
	arrObjsForExport = #()
	
	for objAfter in geometry do 
		(
			intIsLowPoly = findstring objAfter.name strLowPolyPostName
			/*format "\n\n [[%]] -- intIsLowPoly == [[%]]" objAfter.name intIsLowPoly*/
			
			if (intIsLowPoly != undefined) then
				(				
					if (intIsLowPoly > 0)  then
						(
							appendifunique arrObjsForExport objAfter
							/*format "\n\tappended [[%]] to low-poly collection\n" objAfter.name*/
						)
				)
		)
		
	/*print arrObjsForExport*/
		
	max select none
	
	strFileNameForBakedNodes = maxfilepath + (("BAKED__" + (getFilenameFile maxFileName)) + ".max")
	saveNodes arrObjsForExport strFileNameForBakedNodes quiet:true

/*disableSceneRedraw()*/